#!/usr/bin/python 2.7

import sys
import time
import json

class ScriptHandler:
	def __init__(self, _mqttClient, _publichTopic):
		self.mqttClient = _mqttClient
		self.publichTopic = _publichTopic

	def loadFile(self, file):
		with open(file) as scriptFile:
			for line in scriptFile:
				self.parseCmd(line)
				#self.mqttClient.publish(self.publichTopic, line)

	def parseCmd(self, cmd):
		print cmd
		if (cmd[:5] == "DELAY"):
			try:
				delayTime = int(cmd[6:])
				time.sleep(delayTime / 1000)
			except ValueError:
				print('cmd Error: DELAY time must be a integer')
				sys.exit()
		elif (cmd[:2] == "#:"):
			jsonCmd = cmd[2:cmd.find(":#")]
			jcmd = json.loads(jsonCmd)
			self.mqttClient.publish(self.publichTopic, json.dumps(jcmd))

