#!/usr/bin/python 2.7

structrueFilePath="ini\Structure.ini"

class ESLStructure:
	def __init__(self):
		self.structureFile = structrueFilePath
		self.routerDict = dict()
		self.tagDict = dict()
		self.loadiniFile()

	def loadiniFile(self):
		tempRouter=""
		with open(self.structureFile) as iniFile:
			for line in iniFile:
				line = line.replace('\n','')
				if line.find("router") != -1:
					routerAddr = line[(line.find("router")+7):]
					#print line.find("router")
					#print "routerAddr " + routerAddr
					newRouter = ESLRouter(routerAddr)
					tempRouter = routerAddr
					self.routerDict[routerAddr] = newRouter
				elif line.find("tag") != -1:
					tagAddr = line[line.find("tag")+4:]
					#print "tagAddr " + tagAddr
					newTag = ESLTag(tagAddr)
					self.routerDict.get(tempRouter).addTag(tagAddr, newTag)
					self.tagDict[tagAddr]=newTag

	def traversal(self):
		for router in self.routerDict:
			print "[traversal router] %s %s " % (router, self.routerDict[router].getAddr())
			for tag in self.routerDict[router].getTags():
				print "[traversal Tag]" + tag
				print self.routerDict[router].getTags()[tag].getAddr()
				#print "%s %s " % tag, self.routerDict[router].getTags()[tag].getAddr()

	def getRouters(self):
		return self.routerDict

	def getTags(self):
		return self.tagDict

class ESLRouter():
	def __init__(self, _macaddr):
		self.macaddr = _macaddr
		self.tagDict = dict()
		self.r_txpower = 0
		self.t_txpower = 0

	def addTag(self, _ieeeAddr, tag):
		self.tagDict[_ieeeAddr] = tag

	def getAddr(self):
		return self.macaddr

	def getTags(self):
		return self.tagDict

	def setTxPower(self, r_tx, t_tx):
		self.r_txpower = r_tx
		self.t_txpower = t_tx

	def getTxPower(self):
		return [self.r_txpower, self.t_txpower]

class ESLTag():
	def __init__(self, _ieeeAddr):
		self.ieeeAddr = _ieeeAddr
		self.data_request_period = 60
		self.state_request_period = 3600
		self.timeout = 30

	def getAddr(self):
		return self.ieeeAddr

	def setPeriod(self, _data_request_period, _state_request_period):
		self.data_request_period = _data_request_period
		self.state_request_period = _state_request_period

	def getPeriod(self):
		return [self.data_request_period, self.state_request_period]

	def setTimeout(self, _timeout):
		self.timeout = _timeout

	def getTimeout(self):
		return self.timeout